/**
 * @module dixim
 * @submodule server
 */
dixim.namespace('dixim.server');

/**
 * @module server
 * @submodule parental-check-dialog-view
 */

(function() {
var ParentalCheckDialogView;
var prototype;
var superConstructor;
var ModalDialogView = dixim.common.ModalDialogView;
var EventTarget = dixim.event.EventTarget;
var Event = dixim.event.Event;
var _ = dixim.ctt.ResourceBundle.get;
var $ = dixim.ctt.jQuery;

/**
 * @class ParentalCheckDialogView
 * @constructor
 * @param {Object} configs
 */
ParentalCheckDialogView = function(configs) {
    ModalDialogView.call(this, configs);
};

dixim.inherit(ParentalCheckDialogView, ModalDialogView);
dixim.server.ParentalCheckDialogView = ParentalCheckDialogView;
prototype = ParentalCheckDialogView.prototype;
superConstructor = ParentalCheckDialogView.superConstructor;

var CLOSE = 'close';
var OK = 'ok';

var TEMPLATE_BODY_CONTENT = [
    '<div class="dlg_main_msg">', '${description}', '</div>',
    '<div class="dl_tbl">',
    '<dl class="none_border_bottom">',
    '<dt>', '${name}', '</dt>',
    '<dd>',
    '<div class="ui-input-text ui-body-inherit ui-corner-all ui-shadow-inset">',
    '<input type="text" id="pinCode" maxlength="4" />',
    '</div>',
    '</dd>',
    '</dl>',
    '</div>',
].join('');

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    configs = configs || {};

    configs.id = configs.id || '';
    configs.id = [configs.id, 'parental-check-dialog-'].join('');

    configs.bodyContent = TEMPLATE_BODY_CONTENT.
        replace('${description}', _('server_parental_check_dialog_description')).
        replace('${name}', _('server_parental_check_dialog_name'));

    configs.closeButton = dixim.proxy(this.hide, this);
    configs.buttons = [
        {
            text: _('dialog_close'),
            click: dixim.proxy(this.hide, this),
        },
        {
            text: _('dialog_ok'),
            click: dixim.proxy(this._clickOk, this),
        },
    ];

    superConstructor.prototype._initialize.call(this, configs);
};

prototype._clickOk = function() {
    var pinCode = $('#pinCode').val();

    this.dispatchEvent(new Event(OK, {pinCode: pinCode}));
};

}());
