/**
 * @module dixim
 * @submodule vdms
 */
dixim.namespace('dixim.vdms');

/**
 * @module vdms
 * @submodule permission-menu-view
 */

(function() {
var AggregationMenuView;
var prototype;
var superConstructor;
var MenuView = dixim.common.MenuView;
var _ = dixim.ctt.ResourceBundle.get;

/**
 * @class AggregationMenuView
 * @constructor
 * @param {Object} configs
 */
AggregationMenuView = function(configs) {
    MenuView.call(this, configs);
};

dixim.inherit(AggregationMenuView, MenuView);
dixim.vdms.AggregationMenuView = AggregationMenuView;
prototype = AggregationMenuView.prototype;
superConstructor = AggregationMenuView.superConstructor;

var AGGREGATE = 'aggregate';
var NON_AGGREGATE = 'nonAggregate';
var DEFAULT = 'default';
var PREV = 'prev';

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    configs = configs || {};

    configs.title = _('vdms_menu_aggregation');
    configs.menuList = [
        {
            strId: 'vdms_aggregation_menu_aggregation',
            eventParam: AGGREGATE,
        },
        {
            strId: 'vdms_aggregation_menu_non_aggregation',
            eventParam: NON_AGGREGATE,
        },
        {
            strId: 'vdms_aggregation_menu_default',
            eventParam: DEFAULT,
        },
    ];

    superConstructor.prototype._initialize.call(this, configs);
};

}());
